NAME	FPSAV

; Floating point -- Savage (transcendentals and trigonometrics)

; Assembly language subroutine source for PI program.
; Provided to Byte Magazine by:

; MicroWay, Inc.
; PO Box 79
; Kingston MA 02364

; (617) 746-7341

; Copyright (C) MicroWay, Inc., 1986.

.8087

PUBLIC	FPSAV

EXTRN	$LOD$I:FAR
EXTRN	$EXD$I:FAR
EXTRN	$ATD$I:FAR
EXTRN	$TAD$I:FAR

DGROUP	GROUP	COMMON

COMMON	SEGMENT	PARA COMMON 'BLANK'

_DSRC	DW	10240 DUP (?)
_DDEST	DW	10240 DUP (?)
SPC$1_	DD	1.0
SPC$2_	DD	2.0
SPC$3_	DD	3.0
SV$A	DD	0.0
SV$B	DD	?

COMMON	ENDS

CODE	SEGMENT	WORD PUBLIC 'CODE'

ASSUME	CS:CODE, DS:DGROUP

FPSAV	PROC	FAR

	MOV	CX,476
	FINIT
	FLD1
AGAIN:	FMUL	ST,ST(0)
	FSQRT
	CALL	$LOD$I
	CALL	$EXD$I
	CALL	$ATD$I
	CALL	$TAD$I
	FLD1
	FADDP	ST(1),ST
	LOOP	AGAIN

	RET

FPSAV	ENDP

CODE	ENDS

	END
